// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.175.0
//   protoc               v5.27.1
// source: ceal.proto

/* eslint-disable */
import { GrpcMethod, GrpcStreamMethod } from "@nestjs/microservices";
import { Observable } from "rxjs";

export const protobufPackage = "ceal";

export interface ListResponse {
  id: number;
  name: string;
  description: string;
  electionId: number;
}

export interface CreateListRequest {
  name: string;
  description: string;
  electionId: number;
}

export interface GetAllListsRequest {
}

export interface GetListRequest {
  id: number;
}

export interface UpdateListRequest {
  id: number;
  name: string;
  description: string;
  electionId: number;
}

export interface DeleteListRequest {
  id: number;
}

export interface DeleteListResponse {
  success: boolean;
}

export interface AllListsResponse {
  lists: ListResponse[];
}

export interface IntegrantResponse {
  id: number;
  idList: number;
  idUser: number;
}

export interface IntegrantsResponse {
  integrants: IntegrantResponse[];
}

export interface DeleteIntegrantResponse {
  success: boolean;
}

export interface AddIntegrantToListRequest {
  idList: number;
  idUser: number;
  electionId: number;
}

export interface GetIntegrantsByListRequest {
  idList: number;
}

export interface DeleteIntegrantFromListRequest {
  idList: number;
  idUser: number;
}

export interface ElectionIdRequest {
  electionId: number;
}

export const CEAL_PACKAGE_NAME = "ceal";

export interface ListServiceClient {
  createList(request: CreateListRequest): Observable<ListResponse>;

  getAllLists(request: GetAllListsRequest): Observable<AllListsResponse>;

  getList(request: GetListRequest): Observable<ListResponse>;

  updateList(request: UpdateListRequest): Observable<ListResponse>;

  deleteList(request: DeleteListRequest): Observable<DeleteListResponse>;

  addIntegrantToList(request: AddIntegrantToListRequest): Observable<IntegrantResponse>;

  getIntegrantsByList(request: GetIntegrantsByListRequest): Observable<IntegrantsResponse>;

  deleteIntegrantFromList(request: DeleteIntegrantFromListRequest): Observable<DeleteIntegrantResponse>;

  getListsByElectionId(request: ElectionIdRequest): Observable<AllListsResponse>;
}

export interface ListServiceController {
  createList(request: CreateListRequest): Promise<ListResponse> | Observable<ListResponse> | ListResponse;

  getAllLists(request: GetAllListsRequest): Promise<AllListsResponse> | Observable<AllListsResponse> | AllListsResponse;

  getList(request: GetListRequest): Promise<ListResponse> | Observable<ListResponse> | ListResponse;

  updateList(request: UpdateListRequest): Promise<ListResponse> | Observable<ListResponse> | ListResponse;

  deleteList(
    request: DeleteListRequest,
  ): Promise<DeleteListResponse> | Observable<DeleteListResponse> | DeleteListResponse;

  addIntegrantToList(
    request: AddIntegrantToListRequest,
  ): Promise<IntegrantResponse> | Observable<IntegrantResponse> | IntegrantResponse;

  getIntegrantsByList(
    request: GetIntegrantsByListRequest,
  ): Promise<IntegrantsResponse> | Observable<IntegrantsResponse> | IntegrantsResponse;

  deleteIntegrantFromList(
    request: DeleteIntegrantFromListRequest,
  ): Promise<DeleteIntegrantResponse> | Observable<DeleteIntegrantResponse> | DeleteIntegrantResponse;

  getListsByElectionId(
    request: ElectionIdRequest,
  ): Promise<AllListsResponse> | Observable<AllListsResponse> | AllListsResponse;
}

export function ListServiceControllerMethods() {
  return function (constructor: Function) {
    const grpcMethods: string[] = [
      "createList",
      "getAllLists",
      "getList",
      "updateList",
      "deleteList",
      "addIntegrantToList",
      "getIntegrantsByList",
      "deleteIntegrantFromList",
      "getListsByElectionId",
    ];
    for (const method of grpcMethods) {
      const descriptor: any = Reflect.getOwnPropertyDescriptor(constructor.prototype, method);
      GrpcMethod("ListService", method)(constructor.prototype[method], method, descriptor);
    }
    const grpcStreamMethods: string[] = [];
    for (const method of grpcStreamMethods) {
      const descriptor: any = Reflect.getOwnPropertyDescriptor(constructor.prototype, method);
      GrpcStreamMethod("ListService", method)(constructor.prototype[method], method, descriptor);
    }
  };
}

export const LIST_SERVICE_NAME = "ListService";
